
#include "base.as"

#library  lRings                  "Rings.ao"
#library  lModules                "Modules.ao"
#library  lAssociativeAlgebras    "AssociativeAlgebras.ao"

import from lRings,lAssociativeAlgebras,lModules

+++
+++  The category of R-Lie algebras
+++
define LieAlgebra(R:Rings):Category == Module R with 
    bracket: (%,%) -> %
LieAlgebraCategory(R:Rings):MathCategory LieAlgebra R == add

+++
+++  Each associative algebra can be considered a Lie Algebra by defining
+++  [x,y] == xy - yx
+++
AA2LieAlgebra(R:Rings)(A:AssociativeAlgebra R):LieAlgebra R == A add
    Rep == A; import from Rep
    bracket(X:%,Y:%):% == per ( (rep X)*(rep Y) - (rep Y)*(rep X) )
AA2LieAlgebra(R:Rings)(A:AssociativeAlgebra R,B:AssociativeAlgebra R,f:A->B):AA2LieAlgebra(R)(A) -> AA2LieAlgebra(R)(B) == 
    f pretend (AA2LieAlgebra(R)(A) -> AA2LieAlgebra(R)(B)) 

